brain_two/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path("todos/", include("todos.urls")),
    path("admin/", admin.site.urls),
]

todos/urls.py
from django.urls import path

from todos.views import (
    TodoListView,
    TodoDetailView,
    TodoCreateView,
    TodoUpdateView,
    TodoDeleteView,
    TodoItemCreateView,
    TodoItemUpdateView,
)


urlpatterns = [
    path(
        "items/<int:pk>/edit/",
        TodoItemUpdateView.as_view(),
        name="todo_item_update",
    ),
    path("<int:pk>/delete/", TodoDeleteView.as_view(), name="todo_list_delete"),
    path("create/", TodoCreateView.as_view(), name="todo_list_create"),
    path("", TodoListView.as_view(), name="todo_list_list"),
    path("<int:pk>/", TodoDetailView.as_view(), name="todo_list_detail"),
    path("<int:pk>/edit/", TodoUpdateView.as_view(), name="todo_list_update"),
    path(
        "items/create/", TodoItemCreateView.as_view(), name="todo_item_create"
    ),
]

todos/models.py
from django.db import models

# Create your models here.
class TodoList(models.Model):
    name = models.CharField(max_length=100)
    created_on = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.name


class TodoItem(models.Model):
    task = models.CharField(max_length=100)
    due_date = models.DateTimeField(blank=True, null=True)
    is_completed = models.BooleanField(default=False)
    list = models.ForeignKey(
        "TodoList", related_name="items", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.task

todos/views.py
from django.shortcuts import render
from django.views.generic.list import ListView
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.views.generic.detail import DetailView
from django.urls import reverse_lazy

# Create your views here.
from todos.models import TodoList, TodoItem


class TodoListView(ListView):
    model = TodoList
    template_name = "todos/list.html"


class TodoDetailView(DetailView):
    model = TodoList
    template_name = "todos/detail.html"
    fields = ["task"]


class TodoCreateView(CreateView):
    model = TodoList
    template_name = "todos/create.html"
    fields = ["name"]

    def get_success_url(self):
        return reverse_lazy("todo_list_detail", args=[self.object.id])


class TodoUpdateView(UpdateView):
    model = TodoList
    template_name = "todos/edit.html"
    fields = ["name"]

    def get_success_url(self):
        return reverse_lazy("todo_list_detail", args=[self.object.id])


class TodoDeleteView(DeleteView):
    model = TodoList
    template_name = "todos/delete.html"
    success_url = reverse_lazy("todo_list_list")


class TodoItemCreateView(CreateView):
    model = TodoItem
    template_name = "todoitems/create.html"
    fields = ["task", "due_date", "is_completed", "list"]

    def get_success_url(self):
        return reverse_lazy("todo_list_detail", args=[self.object.list.id])


class TodoItemUpdateView(UpdateView):
    model = TodoItem
    template_name = "todoitems/edit.html"
    fields = ["task", "due_date", "is_completed", "list"]

    def get_success_url(self):
        return reverse_lazy("todo_list_detail", args=[self.object.list.id])

todos/templates/todoitems/create.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <main>
        <div>
            <h1>Create a new item</h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <button>Create</button>
            </form>
        </div>
    </main>
</body>
</html>

todos/templates/todoitems/edit.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <main>
        <div>
            <h1>Update item</h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <button>Update</button>
            </form>
        </div>
    </main>
</body>
</html>

todos/templates/todos/create.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <main>
        <div>
            <h1>Create a new list</h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <button>Create</button>
            </form>
        </div>
    </main>
</body>
</html>

todos/templates/todos/delete.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <main>
        <div>
            <h1>Are you sure?</h1>
            <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button>Delete</button>
            </form>
        </div>
    </main>
</body>
</html>

todos/templates/todos/detail.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
<main>
    <div>
        <h1>{{todolist}}</h1>
        <p><a href="{% url 'todo_list_update' todolist.pk %}">Edit</a></p>
        <p><a href="{% url 'todo_list_delete' todolist.pk %}">Delete</a></p>
        <h2>Tasks</h2>
    </div>
    <table>
        <tr>
            <thead>
            <th>Task</th>
            <th>Due date</th>
            </thead>
        </tr>
        <tbody>
        {% for i in todolist.items.all %}
        <tr>
            <td><a href="{% url 'todo_item_update' i.pk %}">{{ i.task }}</td>
            <td>{{ i.due_date }}</td>
        </tr>
        {% endfor %}
        </tbody>
    </table>
</main>
</body>
</html>

todos/templates/todos/edit.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <main>
        <div>
            <h1>Update list</h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <button>Update</button>
            </form>
        </div>
    </main>
</body>
</html>

todos/templates/todos/list.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>
<body>
    <main>
        <div>
            <h1>My lists</h1>
            <p><a href="{% url 'todo_list_create' %}">create a new list</a></p>
            <p><a href="{% url 'todo_item_create' %}">create a new item</a></p>

            <table>
              <thead>
                <tr>
                    <th>Name</th>

                    <th>Number of items</th>
                </tr>
              </thead>
              <tbody>
                {% for i in todolist_list %}
                <tr>
                    <td><a href="{% url 'todo_list_detail' i.pk %}">{{ i.name }}</a></td>
                    <td>{{ i.items.all|length }}</td>
                </tr>
                {% endfor %}
              </tbody>
            </table>
        </div>
    </main>
</body>
</html>